package xyz.pixelatedw.finalbeta;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.item.ItemType;
import net.minecraft.item.PlaceableTileItem;
import net.minecraft.level.TileView;
import net.minecraft.tile.Tile;
import net.minecraft.tile.TileSounds;
import net.minecraft.tile.material.Material;

public class ModTile extends Tile {

	public static final Tile REDSTONE_BLOCK = (new ModTile(100, 176, Material.STONE)).hardness(3.0F).blastResistance(5.0F).sounds(Tile.STONE_SOUNDS).tint(11149858).name("blockRedstone");
	public static final Tile COAL_BLOCK = (new ModTile(101, 103, Material.STONE)).hardness(3.0F).blastResistance(5.0F).sounds(Tile.STONE_SOUNDS).tint(1118481).name("blockCoal");

	static {
		ItemType.byId[REDSTONE_BLOCK.id] = (new PlaceableTileItem(REDSTONE_BLOCK.id - 256)).setName("redstoneBlock");
		ItemType.byId[COAL_BLOCK.id] = (new PlaceableTileItem(COAL_BLOCK.id - 256)).setName("coalBlock");
	}
	
	private int tint = 16777215;

	public ModTile(int id, int texId, Material mat) {
		super(id, texId, mat);
	}

	@Override
	public ModTile hardness(float hardness) {
		return (ModTile) super.hardness(hardness);
	}

	@Override
	public ModTile blastResistance(float resistance) {
		return (ModTile) super.blastResistance(resistance);
	}

	@Override
	public ModTile sounds(TileSounds sounds) {
		return (ModTile) super.sounds(sounds);
	}

	public ModTile tint(int tint) {
		this.tint = tint;
		return this;
	}

	@Override
	@Environment(EnvType.CLIENT)
	public int method_1589(int i) {
		return this.tint;
	}
	
	@Override
	@Environment(EnvType.CLIENT)
	public int getTint(TileView tile, int x, int y, int z) {
		return this.tint;
	}
}
