package xyz.pixelatedw.finalbeta.mixin;

import java.util.Random;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

import net.minecraft.item.ItemType;
import net.minecraft.tile.BookshelfTile;
import net.minecraft.tile.Tile;
import net.minecraft.tile.material.Material;
import xyz.pixelatedw.finalbeta.ModConfig;

@Mixin(BookshelfTile.class)
public class BookshelfTileMixin extends Tile {

	public BookshelfTileMixin(int i, Material j) {
		super(i, j);
	}

	@Inject(method = "getDropCount", at = @At("HEAD"), cancellable = true)
	public void getDropCount(Random random, CallbackInfoReturnable<Integer> cir) {
		if (ModConfig.FIX_BOOKSHELVES_DROP.get()) {
			cir.setReturnValue(3);
		}
	}

	@Override
	public int getDropId(int i, Random random) {
		if (ModConfig.FIX_BOOKSHELVES_DROP.get()) {
			return ItemType.book.id;
		}

		return super.getDropId(i, random);
	}
}
