package xyz.pixelatedw.finalbeta.mixin;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

import net.minecraft.client.ClientInteractionManager;
import net.minecraft.entity.player.Player;
import net.minecraft.item.ItemInstance;
import net.minecraft.item.ItemType;
import net.minecraft.level.Level;
import net.minecraft.tile.Tile;
import net.minecraft.tile.entity.Sign;
import xyz.pixelatedw.finalbeta.ModConfig;

@Mixin(ClientInteractionManager.class)
public class ClientInteractionManagerMixin {
	@Inject(method = "activateTile", at = @At("HEAD"), cancellable = true)
	public void activateTile(Player player, Level level, ItemInstance heldItem, int x, int y, int z, int meta, CallbackInfoReturnable<Boolean> cir) {
		int tileId = level.getTileId(x, y, z);
		if (ModConfig.EDIT_SIGNS.get()) {
			boolean isSign = tileId == Tile.STANDING_SIGN.id || tileId == Tile.WALL_SIGN.id;
			// method_1373 = sneaking check
			if (isSign && player.method_1373()) {
				Sign signTile = (Sign) level.getTileEntity(x, y, z);
				player.openSignScreen(signTile);
				cir.setReturnValue(true);
				return;
			}
		}

		if (heldItem != null && heldItem.itemId == ItemType.sign.id && tileId == Tile.CHEST.id) {
			cir.setReturnValue(heldItem.useOnTile(player, level, x, y, z, meta));
			return;
		}
	}
}
