package xyz.pixelatedw.finalbeta.mixin;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import net.minecraft.container.CraftingContainer;
import net.minecraft.inventory.Inventory;
import net.minecraft.item.ItemInstance;
import xyz.pixelatedw.finalbeta.ModConfig;

@Mixin(CraftingContainer.class)
public class CraftingContainerMixin {

	@Inject(method = "onContentsChanged", at = @At("HEAD"), cancellable = true)
	public void onContentsChanged(Inventory inventory, CallbackInfo ci) {			
		if (!ModConfig.ENABLE_REPAIR.get()) {
			return;
		}
		
		CraftingContainer container = ((CraftingContainer)(Object)this);

		ItemInstance resultItem = null;
		int defaultDamage = 0;
		int damage = 0;

		for (int i = 0; i < inventory.getInvSize(); i++) {
			ItemInstance item = inventory.getInvItem(i);		
			if ((item != null && item.method_723() <= 0) || (item != null && resultItem != null && item.itemId != resultItem.itemId)) {
				resultItem = null;
				break;
			}

			if (item != null && item.method_723() > 0) {
				if (resultItem == null) {
					resultItem = new ItemInstance(item.itemId, 1, item.getDamage());
					defaultDamage = item.method_723() - item.getDamage();
				} else if (item.itemId == resultItem.itemId) {
					damage += item.method_723() - item.getDamage();
				}
			}
		}

		if (resultItem != null && damage > 0) {
			int newDurability = (int) (defaultDamage + damage + Math.floor(resultItem.method_723() / 20));
			newDurability = Math.min(newDurability, resultItem.method_723());

			if (newDurability != defaultDamage) {
				resultItem.setDamage(resultItem.method_723() - newDurability);
				container.result.setInvItem(0, resultItem);
				ci.cancel();
			}
		}
	}
}
