package xyz.pixelatedw.finalbeta.mixin;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

import net.minecraft.level.dimension.Dimension;
import xyz.pixelatedw.finalbeta.ModConfig;

@Mixin(Dimension.class)
public class DimensionMixin {
	private static final float CLOUD_HEIGHT = 108.0F;
	
	@Inject(method = "getCloudHeight", at = @At("RETURN"), cancellable = true)
	private void getCloudHeight(CallbackInfoReturnable<Float> cir) {
		float height = CLOUD_HEIGHT + (CLOUD_HEIGHT * 2.0f * ModConfig.CLOUDS_HEIGHT.get().floatValue());
		cir.setReturnValue(height);
	}
}
