package xyz.pixelatedw.finalbeta.mixin;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import net.minecraft.entity.ItemEntity;
import net.minecraft.entity.player.Player;
import net.minecraft.item.ItemInstance;
import net.minecraft.item.ItemType;
import net.minecraft.level.Level;
import net.minecraft.tile.LeavesTile;
import xyz.pixelatedw.finalbeta.ModConfig;

@Mixin(LeavesTile.class)
public class LeavesTileMixin {
	@Inject(method = "afterBreak", at = @At(value = "INVOKE", target = "Lnet/minecraft/tile/FancyTile;afterBreak(Lnet/minecraft/level/Level;Lnet/minecraft/entity/player/Player;IIII)V"))
	public void afterBreak(Level level, Player player, int x, int y, int z, int meta, CallbackInfo ci) {
		boolean dropItem = level.rand.nextDouble() <= ModConfig.APPLE_DROP_RATE.get();
		if (dropItem) {
			ItemEntity appleItem = new ItemEntity(level, x + 0.5, y - 0.5, z + 0.5, new ItemInstance(ItemType.apple));
			appleItem.pickupDelay = 20;
			level.spawnEntity(appleItem);
		}
	}
}
