package xyz.pixelatedw.finalbeta.mixin;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import net.minecraft.entity.Entity;
import net.minecraft.entity.Minecart;
import net.minecraft.level.Level;
import net.minecraft.util.maths.MathsHelper;
import xyz.pixelatedw.finalbeta.ModConfig;
import xyz.pixelatedw.finalbeta.WyHelper;

@Mixin(Level.class)
public class LevelMixin {

	@Inject(method = "method_242", at = @At("TAIL"))
	public void tick(CallbackInfo ci) {
		WyHelper.playTime++;
	}
	
	@Inject(method="updatePosition", at = @At("TAIL"))
	public void updatePosition(Entity entity, boolean forceUpdate, CallbackInfo ci) {
		if (ModConfig.FURNACE_MINECART_CHUNK_LOADING.get() && entity instanceof Minecart) {
			Minecart minecart = ((Minecart) entity);
			int x = MathsHelper.floor(entity.x);
			int z = MathsHelper.floor(entity.z);
			/*
			 * TODO This is very likely not optimal, we could probably do better
			 * and only load "forward" chunks relative to the cart's direction,
			 * but its barely noticeable in my tests and at least at the moment
			 * I don't care enough for this optimization.
			 */
			int area = 64;
			boolean isRegionLoaded = entity.level.isRegionLoaded(x - area, 0, z - area, x + area, 128, z + area);
			if (!isRegionLoaded && minecart.type == 2) {
				loadRegion(entity.level, x - area, z - area, x + area, z + area);
			}
		}
	}
	
	private void loadRegion(Level level, int minX, int minZ, int maxX, int maxZ) {
		minX >>= 4;
		minZ >>= 4;
		maxX >>= 4;
		maxZ >>= 4;

		for (int x = minX; x <= maxX; ++x) {
			for (int z = minZ; z <= maxZ; ++z) {
				if (!level.getLevelSource().isChunkLoaded(x, z)) {
					level.getLevelSource().loadChunk(x, z);
				}
			}
		}
	}
}
