package xyz.pixelatedw.finalbeta.mixin;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import org.spongepowered.asm.mixin.injection.callback.LocalCapture;

import net.minecraft.entity.Entity;
import net.minecraft.entity.LivingEntity;
import net.minecraft.entity.projectile.Snowball;
import net.minecraft.util.hit.HitResult;
import net.minecraft.util.maths.Vec3d;
import xyz.pixelatedw.finalbeta.ModConfig;

@Mixin(Snowball.class)
public class SnowballMixin {
	// Note, this is actually the "fireball" used by Ghasts. I guess they didn't have the fire charges done yet
	
	@Inject(
		method = "tick",
		at = @At(
			value = "INVOKE",
			target = "Lnet/minecraft/entity/Entity;damage(Lnet/minecraft/entity/Entity;I)Z",
			shift = At.Shift.BEFORE
		),
		locals = LocalCapture.CAPTURE_FAILHARD,
		cancellable = true
	)
	private void newDamageRouter(CallbackInfo ci, Vec3d _v1, Vec3d _v2, HitResult result) {
		Snowball fireball = ((Snowball)(Object)this);
		if (ModConfig.ENABLE_GHASTS_INSTA_DEATH.get() && result != null && !fireball.level.isClient) {
			if (result.entity != null && result.entity.damage(fireball, 0)) {
			}

			fireball.level.createExplosion((Entity) null, fireball.x, fireball.y, fireball.z, 1.0F, true);
			fireball.remove();
			ci.cancel();
		}
	}
	
	@Inject(method = "damage", at = @At(value = "INVOKE", target = "Lnet/minecraft/entity/Entity;getRotation()Lnet/minecraft/util/maths/Vec3d;"), cancellable = true)
	public void damage(Entity attacker, int damage, CallbackInfoReturnable<Boolean> cir) {
		Snowball fireball = ((Snowball)(Object)this);
		if (ModConfig.ENABLE_GHASTS_INSTA_DEATH.get() && attacker instanceof LivingEntity) {
			fireball.field_2193 = (LivingEntity) attacker;
		}
	}
}
