package xyz.pixelatedw.finalbeta.mixin;

import java.util.Random;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import net.minecraft.level.Level;
import net.minecraft.tile.StillFluidTile;
import net.minecraft.tile.material.Material;

@Mixin(StillFluidTile.class)
public class StillFluidTileMixin {
	@Inject(method = "onScheduledTick", at = @At("HEAD"))
	public void onScheduledTick(Level level, int x, int y, int z, Random random, CallbackInfo ci) {
		StillFluidTile tile = ((StillFluidTile) (Object) this);
		if (tile.material == Material.LAVA) {
			if (level.rand.nextInt(10) == 1) {
				level.playSound(x, y, z, "sound3.liquid.lava", 0.5f, 1.0f);
			} else {
				level.playSound(x, y, z, "sound3.liquid.lavapop", 0.5f, 1.0f);
			}
		}
	}
}
